# Originally taken from the Chromium source snappy.gyp, adapted & simplified for node-levelup

# Copyright (c) 2012 The Chromium Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file.

{
'variables': {
    'conditions': [
      # Define an "os_include" variable that points at the OS-specific generated
      # headers.  These were generated by running the configure script offline.
      ['OS=="linux"', {'os_include': 'linux'}],
      ['OS=="mac"', {'os_include': 'mac'}],
      ['OS=="win"', {'os_include': 'win32'}],
    ],
  },
  'targets': [
    {
      'target_name': 'snappy',
      'type': 'static_library',
      'include_dirs': [
        '<(os_include)',
        'snappy-1.0.5',
      ],
      'direct_dependent_settings': {
        'include_dirs': [
          '<(os_include)',
          'snappy-1.0.5',
        ],
      },
      'sources': [
        'snappy-1.0.5/snappy-internal.h',
        'snappy-1.0.5/snappy-sinksource.cc',
        'snappy-1.0.5/snappy-sinksource.h',
        'snappy-1.0.5/snappy-stubs-internal.cc',
        'snappy-1.0.5/snappy-stubs-internal.h',
        'snappy-1.0.5/snappy.cc',
        'snappy-1.0.5/snappy.h',
      ],
    },
    {
      'target_name': 'snappy_unittest',
      'type': 'executable',
      'sources': [
        'snappy-1.0.5/snappy-test.cc',
        'snappy-1.0.5/snappy-test.h',
        'snappy-1.0.5/snappy_unittest.cc',
      ],
      'dependencies': [
        'snappy'
      ],
    },
  ],
}
